
(* 遅延リスト *)
type intg = float Lazy.t list

let last_elem lst = (List.length lst - 1) |> List.nth lst
let intg_append sum y = List.append sum [lazy (y +. Lazy.force (last_elem sum))]

let rec intg sum xl =
  match xl with
  | nil -> sum
  | x :: xs -> intg (intg_append sum x) xs 

    
let () =
  let lst1 = intg_append [lazy (print_endline "calc"; 0.)] 1. in
  let lst2 = intg_append lst1 2. in
  let lst3 = intg_append lst2 3. in
  let sum3 = Lazy.force (last_elem lst2) in
  let sum2 = Lazy.force (last_elem lst3) in
  print_float sum3;
  print_string " ";
  print_float sum2;
  print_endline ""
